﻿// --------------------------------------------------------------
// Beispiel:...\Kapitel 23\Drucken
// --------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace Drucken
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }



    // allgemeine Zeichenroutine zum Zeichnen in die PictureBox und zur Druckerausgabe
    private void DrawGraphic(Graphics g, int x1, int y1, int x2, int y2)
    {
      Pen pen = new Pen(Color.Black);
      for (int i = x1; i <= x2; i += 20)
        g.DrawLine(pen, x1, y1, i, y2);

      for (int i = x2; i >= x1; i -= 20)
        g.DrawLine(pen, x2, y1, i, y2);
    }

    private void pictureBox1_Paint(object sender, PaintEventArgs e)
    {
      this.DrawGraphic(e.Graphics, 0, 0, pictureBox.ClientSize.Width, pictureBox.ClientSize.Height);
    }

    private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
    {
      this.DrawGraphic(e.Graphics, e.MarginBounds.X, e.MarginBounds.Y, e.MarginBounds.Width + e.MarginBounds.X, e.MarginBounds.Height + e.MarginBounds.Y);
    }



    // Menü: Drucken
    private void mnuDrucken_Click(object sender, EventArgs e)
    {
      if (printDialog1.ShowDialog() == DialogResult.OK)
        printDocument1.Print();
    }


    // Menü: Seite einrichten
    private void mnuSeiteEinrichten_Click(object sender, EventArgs e)
    {
      pageSetupDialog1.ShowDialog();
    }


    // Menü: Druckvorschau
    private void mnuDruckvorschau_Click(object sender, EventArgs e)
    {
      if (printPreviewDialog1.ShowDialog() == DialogResult.OK)
        printDocument1.Print();
    }


    // Menü: Druckvorschau (erweitert)
    private void mnuUserDefPrintPreview_Click(object sender, EventArgs e)
    {
      Form2 frm = new Form2();
      frm.printPreviewControl1.Document = printDocument1;
      frm.ShowDialog();
    }
  }
}