﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics; // Für Zeitmessung mit Stopwatch
using MPS; // Aus MultimediaTimer.dll
using System.Runtime.InteropServices;// if using dll




namespace TimerTest
{
    public partial class FormTimerTest : Form
    {
        public FormTimerTest()
        {
            InitializeComponent();
            toolStripStatusLabel1.Text = " Zählfrequenz= "+Stopwatch.Frequency.ToString()+" Hz";
            stopwatch.Start();
            starttmMM = stopwatch.ElapsedTicks;

            MMTimer1 = new TMultimediaTimer(null); // --> null means no callback invoking --> less overhead 
                                                   //       --> less CPU load
            MMTimer1.Interval = 10;                 // --> 10ms interval
            MMTimer1.OnTimer = EventVomMMTimer;
            MMTimer1.Enable();

            int ex;
            ex = me2600AOSetMode(0, 0, me2600Def.AO2600_MINUS_10, me2600Def.AO2600_TRANSPARENT);
            if (ex == 1) label2.Text = "OK"; else label2.Text = "NOK";
            int iDLLVersion = me2600GetDLLVersion();
            labelVer.Text = iDLLVersion.ToString();
            int iSerialNumber = 0;
            ex = me2600GetSerialNumber(0, out iSerialNumber);
            if (ex == 1) label2.Text += "OK"; else label2.Text += "NOK";
            labelSerNb.Text = iSerialNumber.ToString();
            if (iSerialNumber == 0) MMTimer1.Disable(); else MMTimer1.Enable();

        }

        [DllImport("ME2600.DLL")]
        public extern static int me2600AOSetMode(int iBoardNumber, int iChannel, int iRange, int iMode);

        [DllImport("ME2600.DLL")]
        public extern static int me2600AOSingle(int iBoardNumber, int iChannel, short iValue);

        [DllImport("ME2600.DLL")]
        public extern static int me2600GetDLLVersion();

        [DllImport("ME2600.DLL")]
        public extern static int me2600GetSerialNumber(int bnb, out int Sernb);



        Stopwatch stopwatch = new Stopwatch();

        TMultimediaTimer MMTimer1;
        double starttmMM, stoptmMM, timeAvrMM = 0;
        int cntMM = 1;

        private void timer1Sec_Tick(object sender, EventArgs e)
        {
           labelMMTimer.Text = (timeAvrMM / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
            timeAvrMM = 0;
            cntMM = 0;
        }


        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
           MMTimer1.Disable();
            MMTimer1.Interval = (uint)numericUpDown1.Value; // Kann nur verstellt werden, wenn er stoppt
            MMTimer1.Enable();

        }

        private void FormTimerTest_FormClosing(object sender, FormClosingEventArgs e)
        {
            MMTimer1.Disable();
        }

        void EventVomMMTimer(TMultimediaTimer sender)
        {
            starttmMM = stoptmMM;
            stoptmMM = stopwatch.ElapsedTicks;
            timeAvrMM += (stoptmMM - starttmMM);
            cntMM++;
            me2600AOSingle(0, 0, 2253);// 1V
            me2600AOSingle(0, 0, 2048);// 0V
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

    }
}
